//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>
#include <functional>

#include "compose22.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
//  string s("Internationalization");
//  string sub("Nation");
  string s("");
  string sub("");

  //       (  )
  string::iterator pos;
  pos = search (s.begin(),s.end(),           // 
                sub.begin(),sub.end(),       //  
                compose_f_gx_hy(equal_to<int>(), //  
                                ptr_fun(::toupper),
                                ptr_fun(::toupper)));

    if (pos != s.end()) {
        cout << "\"" << ToRus(sub) << "\"" << ToRus("  ") << "\"" << ToRus(s) << "\""
             << endl;
    }


  getch();
  return 0;
}

//---------------------------------------------------------------------------